#!/usr/bin/python 2.7

import sys
from PIL import Image
from struct import *

def BmpToRGB(Bmpfile):
	bmp_image = Image.open(Bmpfile)
	rgb_im = bmp_image.convert('RGB')
	width,height = bmp_image.size
	imageArray = {}
	for i_height in range(height):
		#print str(i_height) + "[",
		for i_width in range(width):
			pixel_value = rgb_im.getpixel((i_width, i_height))
			if pixel_value == (255, 255, 255): #Write
				imageArray[i_width, i_height] = 'w'
				#print " w",
			elif pixel_value == (0, 0, 0): #Black
				imageArray[i_width, i_height] = 'b'
				#print " b",
			elif pixel_value == (255, 0, 0): #Red
				imageArray[i_width, i_height] = 'r'
				#print " r",
			else:
				if (pixel_value[0] > 200) and (pixel_value[1] < pixel_value[0]) and (pixel_value[2] < pixel_value[0]): #Red
					imageArray[i_width, i_height] = 'r'
				else: #gray color
					level = pixel_value[0] * 0.299 + pixel_value[1] * 0.587 + pixel_value[2] * 0.144 #covert to Y(YUV)
					if (level > 192): #Write
						imageArray[i_width, i_height] = 'w'
					else: #Black
						imageArray[i_width, i_height] = 'b'
		#print "]"
	return imageArray

def colorToDTM1(image, height, index, file): #debug 
	total = 0
	for i in range(2):
		pixel = image[(index + i), height]
		if (pixel == 'b'): #black 000
			#print " B ",
			file.write(" B ")
		elif (pixel == 'r'): #red 100
			if (i == 1):
				res = 0b100<<4
			else:
				res = 0b100
			total = res + total
			#print " R ",
			file.write(" ! ")
		elif (pixel == 'w'): # white 011
			if (i == 1):
				res = 0b1111<<4
			else:
				res = 0b1111
			total = res + total
			#print " W ",
			file.write("   ")
	#print bin(total)  
	return total

def BmpToPixel(input, output, logfile):
	bmpImg = Image.open(input)
	width,height = bmpImg.size
	rgbTable = BmpToRGB(input)
	f = open(output, 'wb')
	print "Image Convert processing"
	for i_height in range(height):
		logfile.write("\nLine:" + str(height))
		for i_width in range(0,width,2):
			byte2 = colorToDTM1(rgbTable, i_height, i_width, logfile)
			f.write(pack("B", byte2))
		#print ""
	print "Image Convert Done"

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Program start
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
if __name__ == '__main__':
	log = open('logfile', 'w')
	if len(sys.argv) < 3:
		print 'argument 1 = input bmp  Ex: test.bmp'
		print 'argument 2 = output file  Ex: result'
		sys.exit()
	BmpToPixel(sys.argv[1], sys.argv[2], log)
	